import java.io.*;
import java.util.*;


public class TestCaseFile  {
    private Vector v;
	String vdir;
	String vFileName;
	File vfile;
	FileInputStream vin;
	FileOutputStream vout;
	ObjectInputStream vis;
	ObjectOutputStream vos;
	boolean fileOpen;
	boolean fileWritten;

	public  TestCaseFile(String dir, String nm) {
	        vdir=dir;
	        vFileName=nm;
		fileOpen=false;
    }
	public boolean fileExists() {
		boolean existence;
		if(fileOpen) {
			existence = true;
		} else {
			try {
				getTheVector();
				existence = true;
			} catch (Exception oops) {
				existence = false;
			}
		}
		return existence;
	}
	public String getParent() throws Exception  {
		String ap;
		File afile = new File(vdir);
		ap=afile.getCanonicalPath();
		return ap;
	}
	public int getSize() throws Exception {
		int vectorSize;
		if (!fileOpen) {
			try {
				vectorSize = getTheVector().size();
			}
			catch (Exception oops) {
				System.err.println ("Could not get vector");
				throw oops;
			}
		}
		else {
			vectorSize = v.size();
			}
		return vectorSize;
	}
			
			
	
			
    public Vector getTheVectorForUpdate() throws Exception {
        try {

		 
	        closeFile();
        } catch (Exception oops) {
		    System.err.println("problem closing old output  "+oops);
		    throw oops;
        }
    try {
            vfile = new File(vdir, vFileName);
            vin = new FileInputStream(vfile);

    } catch (Exception oops) {
		System.err.println("problem opening new Input  "+oops);
		throw oops;
    }
    try {
            vis = new ObjectInputStream(vin);
	        v=(Vector) vis.readObject();
	       
    } catch (Exception oops) {
		System.err.println("problem reading object " + oops);
		vis.close();
		throw oops;
    }
    try {
	    openFile();
    } catch (Exception oops) {
	    System.err.println("problem opening output" + oops);
	    throw oops;
    }
	return  (Vector)v.clone();
}
    
public Vector getTheVector() throws Exception{
    
        try {
	        if (!fileOpen) {
           	    vfile = new File(vdir, vFileName);
          	    vin = new FileInputStream(vfile);
           	    vis = new ObjectInputStream(vin);
		        v=(Vector) vis.readObject();
		    	vis.close();
			}
	        return v;
            
        } catch (Exception oops) {
		    System.err.println("problem getting the vector "+oops);
			throw oops;
		}
     //   return new Vector();
}
    public void putTheVector(Vector vArg) throws Exception {
            closeFile();
		    openFile();
        v=vArg;
            try {
                vos.writeObject(v);
                vos.flush();
                fileWritten=true;
               
            } catch (Exception oops) {
                System.err.println("Problems writing object " + oops);
                throw oops;
            }
    }
 protected void finalize() throws Exception {
		closeFile();
}
	
	public void dumpVector() {
		Enumeration theList;
		TempConverterTestCase tc;
		if (!v.isEmpty()) {
			theList=v.elements();
			while (theList.hasMoreElements()) {
				tc=(TempConverterTestCase) theList.nextElement();
				System.out.println(tc.toString());
			}
			System.out.println("Count: " + String.valueOf(v.size()));
		} else {
			System.out.println("empty");
		}
	}
				
			
    public void openFile() throws Exception {
         vfile = new File(vdir, vFileName);
            try {
                vout = new FileOutputStream(vfile);
                vos = new ObjectOutputStream(vout);
            
            }catch (Exception oops) {
                System.err.println("Problems with output stream " + oops);
                throw oops;
            }
            fileOpen=true;
            fileWritten=false;
    }
    public void closeFile() throws IOException {
        
 
        try {
            if (fileOpen) {
                if (!fileWritten) {
                      try {
                        vos.writeObject(v);
                        vos.flush();
                        fileWritten=true;
                        fileOpen=true;
                      } catch (IOException oops) {
                        System.err.println("Problems writing object " + oops);
                        throw oops;
                       }
                }
                vos.close();
                fileOpen=false;
                fileWritten=false;
            }
        } catch (IOException io) {
            System.err.println("Problem closing " + io);
            throw io;
        }
    }
            
}
